routes/web.php
<?php

use App\Http\Controllers\BookController;
use App\Http\Controllers\BorrowController;
use App\Http\Controllers\GenreController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Input;
use Illuminate\Http\Request;

use App\Models\Book;
use App\Models\User;
use App\Models\Genre;
use App\Models\Borrow;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    $user_count = User::count();
    $book_count = Book::count();
    $genre_count = Genre::count();
    $accepted_borrow_count = Borrow::active_rentals()->count();
    $genres = Genre::all();

    return view('index', [
        'user_count' => $user_count,
        'book_count' => $book_count,
        'genre_count' => $genre_count,
        'accepted_borrow_count' => $accepted_borrow_count,
        'genres' => $genres
    ]);
});

Route::resource('books', BookController::class);
Route::resource('genres', GenreController::class);
Route::resource('borrows', BorrowController::class);

Route::get('/user/rentals', function() {
    $user = Auth::user();

    $b_pending = Borrow::where('reader_id', $user['id'])->
                         where('status', 'PENDING')->
                         get();

    $b_intime = Borrow::where('reader_id', $user['id'])->
                        where('status', 'ACCEPTED')->
                        where('deadline', '>=', now())->
                        get();

    $b_overdue = Borrow::where('reader_id', $user['id'])->
                         where('status', 'ACCEPTED')->
                         where('deadline', '<', now())->
                         get();

    $b_rejected = Borrow::where('reader_id', $user['id'])->
                          where('status', 'REJECTED')->
                          get();

    $b_returned = Borrow::where('reader_id', $user['id'])->
                          where('status', 'RETURNED')->
                          get();

    return view('borrow.user', [
        'b_pending' => $b_pending,
        'b_intime' => $b_intime,
        'b_overdue' => $b_overdue,
        'b_rejected' => $b_rejected,
        'b_returned' => $b_returned,
    ]);
})->middleware('auth');

Route::get('/profile', function() {
    $user = Auth::user();
    if (!$user) {
        return abort(403);
    }

    return view('profile', [
        'user' => $user
    ]);
});

Auth::routes();

Route::get('/logout', '\App\Http\Controllers\Auth\LoginController@logout');

app/Models/Genre.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Genre extends Model
{
    use HasFactory, SoftDeletes;

    protected $fillable = [
        'name',
        'style'
    ];

    public function books() {
        return $this->belongsToMany(Book::class);
    }

    public static function find_by_name($name) {
        return Genre::query()->where('name', '=', $name)->first();
    }
}

app/Http/Controllers/GenreController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreGenreRequest;
use App\Http\Requests\UpdateGenreRequest;
use App\Models\Genre;
use Illuminate\Validation\Rule;

class GenreController extends Controller
{
    static function get_validator() {
        return [
            'name' => 'required|min:3|max:255',
            'style' => [
                'required',
                Rule::in(GenreController::$styles),
            ]
        ];
    }

    static $styles = [
        'primary',
        'secondary',
        'success',
        'danger',
        'warning',
        'info',
        'light',
        'dark',
    ];

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $this->authorize('view', Book::class);
        return view('genre.list', [
            'genres' => Genre::all(),
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $this->authorize('create', Genre::class);

        return view('genre.create', [
            'styles' => GenreController::$styles,
            'init' => function($name) {
                return old($name);
            }
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \App\Http\Requests\StoreGenreRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreGenreRequest $request)
    {
        $this->authorize('create', Genre::class);
        $val = $request->validate(GenreController::get_validator());

        $genre = Genre::create($val);
        $genre->save();

        return redirect()->route('genres.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Genre  $genre
     * @return \Illuminate\Http\Response
     */
    public function show(Genre $genre)
    {
        $books = $genre->books();
        
        return view('genre.show', [
            'genre' => $genre,
            'books' => $books
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Genre  $genre
     * @return \Illuminate\Http\Response
     */
    public function edit(Genre $genre)
    {
        $this->authorize('update', Genre::class);

        return view('genre.edit', [
            'id' => $genre['id'],
            'styles' => GenreController::$styles,
            'init' => function($name) use($genre) {
                return $genre[$name];
            }
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \App\Http\Requests\UpdateGenreRequest  $request
     * @param  \App\Models\Genre  $genre
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateGenreRequest $request, Genre $genre)
    {
        $this->authorize('update', Genre::class);
        $val = $request->validate(GenreController::get_validator());

        $genre->update($val);
        $genre->save();

        return redirect()->route('genres.show', ['genre' => $genre['id']]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Genre  $genre
     * @return \Illuminate\Http\Response
     */
    public function destroy(Genre $genre)
    {
        $this->authorize('delete', Genre::class);
        $genre->delete();
        return redirect()->route('genres.index');
    }
}

resources/views/genre/create.blade.php
@extends('layouts.general')
@section('title', 'Create new genre')
@section('content')

<div class="container-sm">
    <h1 class="mt-5">Create New Genre</h1>

    <form action="/genres" method="POST">
        @csrf

        @include('genre.form', ['init'=>$init, 'options'=>$styles])

        <div class="mt-3">
            <input type="submit" class="btn btn-success" value="Add Book">
            <input type="reset" class="btn btn-danger" value="Reset">
        </div>        
    </form>
</div>

@endsection

resources/views/genre/edit.blade.php
@extends('layouts.general')
@section('title', 'Edit genre')
@section('content')

<div class="container-sm">
    <h1 class="mt-5">Edit Genre</h1>

    <form action="/genres/{{$id}}" method="post">
        @csrf
        @method('patch')

        @include('genre.form', ['init'=>$init, 'options'=>$styles])

        <div class="mt-3">
            <input type="submit" class="btn btn-success" value="Save">
            <input type="reset" class="btn btn-danger" value="Reset">
        </div>        
    </form>
</div>

@endsection

resources/views/genre/form.blade.php
@include('components.formfield', [ 'title'=>'Name', 'name'=>'name', 'type'=>'text', 'init'=>$init ])
@include('components.dropdown', [
    'title'=>'Style',
    'name'=>'style',
    'init'=>$init,
    'options'=>$styles ])

resources/views/genre/list.blade.php
@extends('layouts.general')
@section('title', 'Genres')
@section('content')

<div class="container-sm">
    <h1 class="mt-5">Genres</h1>

    <table class="table">
        <thead>
            <td>Name</td>
            <td>Syle</td>
            <td>Details</td>
            <td>Delete</td>
        </thead>
        @foreach ($genres as $g)
        <tr>
            <td>{{$g['name']}}</td>
            <td>{{$g['style']}}</td>
            <td><a class="btn btn-primary" href="/genres/{{$g['id']}}/edit">edit</a></td>
            <td>
                <form action="{{ route('genres.destroy', ['genre'=>$g['id']]) }}" method="post">
                    @csrf
                    @method('delete')
                    <input type="submit" class="btn btn-danger" value="Delete">
                </form>
            </td>
        </tr>
        @endforeach
    </table>
</div>

@endsection

resources/views/genre/show.blade.php
@extends('layouts.general')

@section('title', 'Genre: ' . $genre['name'])

@section('content')

<div class="container-sm">
    <h2>Genre: {{ $genre['name'] }}</h2>
</div>

@include('components.booklist', [ 'books' => $genre->books ])

@endsection